/*# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
#                        pour la Sant�)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and
#  abiding by the rules of distribution of free software. You can  use,
#  modify and/ or redistribute the software under the terms of the CeCILL-B
#  license as circulated by CEA, CNRS and INRIA at the following URL
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability.
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------ */

//=====
// Don't edit this file. This file is generated from xml description..
//=====
#include "bbcreaMaracasVisuManualPaint.h"
#include "bbcreaMaracasVisuPackage.h"

#include "ManualPaintPanel.h"
#include "ManualPaintModel.h"
#include "ManualPaintControler.h"
#include "wxManualPaintPanel.h"

#include <wx/msgdlg.h>

namespace bbcreaMaracasVisu
{


//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------


BBTK_ADD_BLACK_BOX_TO_PACKAGE(creaMaracasVisu,ManualPaint)
BBTK_BLACK_BOX_IMPLEMENTATION(ManualPaint,bbtk::WxBlackBox);
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::Process()
{
    if (bbGetInputWxVtkBaseView1()==NULL)
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ManualPaint) Input 'WxVtkBaseView' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }
    if (bbGetInputIn()==NULL)
    {
      wxMessageDialog(NULL,  bbtk::std2wx("(ManualPaint) Input 'vtkImageData' is not set"),  bbtk::std2wx(bbGetFullName()) ).ShowModal();
    }
    if (firsttime==true)
    {
        firsttime=false;
        ManualPaintModel        *mpModel		= new ManualPaintModel();
        ManualPaintControler    *mpControler    = new ManualPaintControler();
        mpModel->SetImages( bbGetInputIn() , bbGetInputIn2() );
        mpControler->SetManualPaintModel(mpModel);
        mpControler->SetWxVtk2DBaseView( 1, (wxVtk2DBaseView*)bbGetInputWxVtkBaseView1() );
        mpControler->SetWxVtk2DBaseView( 2, (wxVtk2DBaseView*)bbGetInputWxVtkBaseView2() );
        mpControler->SetWxVtk2DBaseView( 3, (wxVtk2DBaseView*)bbGetInputWxVtkBaseView3() );
        mpControler->SetWxVtk2DBaseView( 4, (wxVtk2DBaseView*)bbGetInputWxVtkBaseView4() );
		mpControler->Config();
        wxManualPaintPanel       *mpPanel			= (wxManualPaintPanel*)bbGetOutputWidget();
	    mpPanel->SetManualPaintControler(mpControler);
    } // firsttime
}

//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::CreateWidget(wxWindow* parent)
{
   bbSetOutputWidget( new wxManualPaintPanel(parent) );
}

//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserSetDefaultValues()
{
    firsttime = true;
    bbSetInputIn(NULL);
    bbSetInputWxVtkBaseView1(NULL);
    bbSetInputWxVtkBaseView2(NULL);
    bbSetInputWxVtkBaseView3(NULL);
    bbSetInputWxVtkBaseView4(NULL);
}
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserInitializeProcessing()
{

}
//=====
// Don't edit this file. This file is generated from xml description..
//=====
void ManualPaint::bbUserFinalizeProcessing()
{

}

} // EO namespace bbcreaMaracasVisu


